<?php

namespace Drupal\standwithukraine\Service;

use Drupal\Core\Entity\EntityTypeManagerInterface;
use Drupal\Core\Session\AccountProxyInterface;
use Drupal\user\RoleInterface;

/**
 * Defines the helper service.
 */
class StandWithUkraineHelper implements StandWithUkraineHelperInterface {

  /**
   * The current active user.
   *
   * @var \Drupal\Core\Session\AccountProxyInterface
   */
  protected $currentUser;

  /**
   * The role storage.
   *
   * @var \Drupal\user\RoleStorageInterface
   */
  protected $storage;

  /**
   * {@inheritdoc}
   */
  public function __construct(
    AccountProxyInterface $current_user,
    EntityTypeManagerInterface $entity_type_manager
  ) {
    $this->currentUser = $current_user;
    $this->storage = $entity_type_manager->getStorage('user_role');
  }

  /**
   * {@inheritdoc}
   */
  public function access() {
    foreach ($this->currentUser->getRoles() as $role_id) {
      if (
        ($role = $this->storage->load($role_id)) instanceof RoleInterface &&
        !$role->isAdmin() &&
        $role->hasPermission('standwithukraine hide message')
      ) {
        return FALSE;
      }
    }

    return TRUE;
  }

}
